// 5 ϥ
// rule.c  롼Ƚ
#include <stdio.h>
#include <stdlib.h>

// إåեɤ߹
#include "game.h"
#include "board.h"
#include "move.h"
#include "rule.h"

// ѥ٥ȥ
const Point delta[] = {
    {0,0}, {0,-1}, {0,1}, {-1,0}, {1,0}
};

// 
Dir getdir(Point from, Point to) {
    int dx = to.x - from.x;
    int dy = to.y - from.y;
    if (dx * dy) return dir_none;
    for (Dir d=dir_U; d <= dir_R; d++) {
        int x = dx * delta[d].x;
        int y = dy * delta[d].y;
        if (x >= 0 && y >= 0 && x+y > 0) return d; 
    }
    return dir_none;
}

// ʹؿ
inline int abs(int x) { return (x<0)?(-x):(x); }

// ӱۤȽ
bool isjump(Point from, Point to) {
    int x = abs(from.x - to.x);
    int y = abs(from.y - to.y);
    return (x==2 && y==0) || (x==0 && y==2);
}

// ܤȽ
bool isnext(Point from, Point to) {
    int x = abs(from.x - to.x);
    int y = abs(from.y - to.y);
    return (x==1 && y==0) || (x==0 && y==1);
}

// ư롼
const Rule rules[2][MAXRULE] = {
    { rule_black_move1, rule_black_move2, 0 },
    { rule_white_move1, 0 }
};

// 롼븡
bool check_rules(const Move *mp, const Board *bp) {
    /* todo: ư/ưȽ */
    for (int i=0;i<MAXRULE;i++) {
        Rule r = rules[bp->turn][i];
        if (r == 0) break;
        if ((*r)(mp,bp)) return true;
    }
    return false;
}

// ΰư롼1(ܥޥ)
bool rule_black_move1(const Move *mp, const Board *bp) {
    return  getcolor(bp,mp->from) == c_black &&
            getcolor(bp,mp->to) == c_empty &&
            getdir(mp->from, mp->to) != dir_none &&
            isnext(mp->from, mp->to);
}

// ؿ
Point inter(Point from, Point to) {
    Point p;
    p.x = (from.x+to.x)/2;
    p.y = (from.y+to.y)/2;
    return p;
}

// ΰư롼2(ӱۤ)
bool rule_black_move2(const Move *mp, const Board *bp) {
    return  getcolor(bp,mp->from) == c_black &&
            getcolor(bp,mp->to) == c_empty &&
            isjump(mp->from, mp->to) &&
            getcolor(bp, inter(mp->from, mp->to)) == c_white;
}

// ΰư롼1(ܥޥ)
bool rule_white_move1(const Move *mp, const Board *bp) {
    return  getcolor(bp,mp->from) == c_white &&
            getcolor(bp,mp->to  ) == c_empty &&
            getdir(mp->from, mp->to) != dir_none &&
            isnext(mp->from, mp->to);
}

// 
bool check_black_win(const Board *bp) { return bp->white_leave<=LIMIT; }
bool check_white_win(const Board *bp) { return false; /* todo: */}

// Ƚ
Winner check_winner(const Board *bp) {
    return  check_black_win(bp)? black_win :
            check_white_win(bp)? white_win : none ;
}

// ɽ
const char *turnname[] = { "black", "white", 0 };
const char *winname[] = { "none", "black", "white", 0 };

void show_winner(Winner w) {
    printf("%s win\n", winname[w]);
}
