// 7 member.c
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "member.h"

static int used=0;

inline Member *new_member() {
    Member *mp = (Member*)malloc(sizeof(Member));
    if (mp==0) return 0;
    bzero(mp,sizeof(Member));
    used++;
    return mp;
}

inline void delete_member(Member *mp) {
    free(mp);
    used--;
}

char *gettoken(char **s, int maxlen) {
    if (s==0 || *s==0) return "";
    char *s2=*s;
    int i=0;    
    while (*s2 && i<maxlen) {
      if (isspace(*s2)) break; 
      s2++; i++;
    }
    if (i<maxlen) *s2++ = 0;
    char *r = malloc(s2-(*s)+1);
    strncpy(r, *s, maxlen);
    r[maxlen] = 0;
    *s = s2;
    return r;
}

Member *read_member(FILE *ifp) {
    char buf[256];
    char *s=buf;
    if (fgets(s,255,ifp) == 0) return 0;
    Member *mp = new_member();
    if (mp==0) return 0;
    mp->name    = gettoken(&s,255);
    mp->address = gettoken(&s,255);
    return mp;
}

void write_member(const Member *mp,FILE *ofp) {
    fprintf(ofp, "(%s,%s)\n", mp->name, mp->address);
}

void read_member_list(Member *mp) { 
    Member *mp2;
    while (mp2 = read_member(stdin)) {
       mp->next=mp2;
       mp=mp2;
    }
}

void write_member_list(const Member *mp) {
    if (mp==0) return;
    mp=mp->next;
    while (mp) {
        write_member(mp,stdout);
        mp = mp->next;
    }
}

void delete_member_list(Member *mp) {
    Member *mp2;
    if (mp==0) return;
    mp2=mp->next; mp->next=0; mp=mp2;
    while (mp) {
        mp2=mp->next;
        delete_member(mp);
        mp = mp2;
    }
}

Member root; // ꥹȤƬ

int main() { 
    read_member_list(&root); 
    write_member_list(&root);
    printf("used=%d\n",used);
    delete_member_list(&root);
    printf("used=%d\n",used); // 0ʳʤ꡼ȯ
    write_member_list(&root);
    return 0; 
}
